#ifndef PROVIDER_H
#define PROVIDER_H

#include "serializable.h"

#include "taskmanager.h"

class AbstractProvider : public Serializable
{
public:
    virtual Task* getTask() = 0;
};

template <typename T>
class Provider : public AbstractProvider
{
protected:
    struct ProviderTask : public Task
    {
        T* m_object = nullptr;
        int m_progress = 0;
        int m_flags;
        std::string m_providerName;

        /**
         * @brief This should be overloaded
         */
        virtual void performTask() { m_object = new T(); m_progress = 1; }

        virtual int getProgressInt() {  }
        virtual Task::TaskTypeFlags getFlags() { return m_flags; }
        virtual const std::string &getLabel() { return m_providerName; }
    };

    ProviderTask m_task;
public:
    virtual Task* getTask() { return (Task*)&m_task; }
    virtual T* provide() { return m_task.m_object; }
};

#endif // PROVIDER_H
